#!/usr/bin/perl
#
#   Bluestem - University of Illinois WWW Identification Service
#
#   test.cgi - Bluestem API Test CGI
#

use strict;
use warnings;
use lib "/var/www/bluestem-client/lib";
use BlueRPC ();
use Bluestem::Client ();

my $bsc = Bluestem::Client->new();
my($response) = BlueRPC::bluerpc_cgi(
	$bsc->{conf}{server_key},
	{'Bluestem.Login' => sub {
		my($cacheid,$netid,$clientip,$clusterconf,$checksum,$userconf) = @_;
		eval {
			$bsc->update_cacheentry($cacheid,$netid,undef,$clientip,$userconf);
		};
		return "100 $@" if $@;
		
		my %iservers;
		for my $line ( split /\n/, $clusterconf ) {
			my($iserver,$weight,$flags) = $line =~ m/^([a-zA-Z]\S*)\s+(\d\S*)\s+(\S+)/
				or next;
			next if $flags =~ m/d/;
			$iservers{$iserver} = { weight => $weight };
			$iservers{$iserver}{primary} = 1 if $flags =~ m/p/;
		}
		$bsc->id_servers_update( \%iservers );

   		return "0 $cacheid $netid logged in";
	}},
);
binmode(STDOUT);
print $response;
