package LBluestem;
use strict;
use warnings;

use CGI ();
use Bluestem::CGIClient ();
my $cgi = CGI->new();
my $bsc = Bluestem::CGIClient->new(cgi => $cgi);

our $C_ServerNamePort = $bsc->{conf}{servername};
our $C_ServerNamePortCookie = $C_ServerNamePort;
$C_ServerNamePortCookie =~ tr/:/_/;
our $C_ScriptName = "https://".$cgi->server_name().$bsc->{conf}{cgipath}."/lb_login.".($bsc->{conf}{is_iis}?'pl':'cgi');
our $C_NT = 0;
our $C_ImgPath = $bsc->{conf}{imgpath};
our $C_CacheDir = $bsc->{conf}{cache_dir};

sub main::lb_id {
	my $session = $bsc->get_session()
		or return;
	return(
		$bsc->bluestem_id_short($session->{netid}),
		$session->{idle},
		$session->{age}
	);
}

sub main::lb_login {
	my($loginurl, $lb_msg, $lb_prior, $lb_debug) = @_;
	$loginurl ||= "https://".$cgi->server_name().$bsc->{conf}{cgipath}."/lb_login.".($bsc->{conf}{is_iis}?'pl':'cgi');

	$bsc->end_session();
	
	if ($lb_msg) {
		$cgi->param(lb_msg => Bluestem::Client::a2h($lb_msg));
	}
	if ($lb_prior) {
		if ($lb_prior =~ /^\d+$/) {
			$cgi->param(lb_prior => $lb_prior);
		} else {
			main::lb_log("invalid lb_prior auth value ignored ($lb_prior)");
		}
	}
	if ($lb_debug) {
		if ($lb_debug =~ /^\d+$/) {
			$cgi->param(lb_debug => $lb_debug);
		} else {
			main::lb_log("invalid lb_debug value ignored ($lb_debug)");
		}
	}

	$loginurl .= $cgi->url('-absolute'=>1,'-query'=>1);

	print $cgi->redirect(
		-uri=>$loginurl,
		-expires => "-1d",
	);

	exit 0;
}

sub main::lb_relogin {
	my($lb_msg, $lb_prior, $lb_debug) = @_;
	main::lb_login(undef, $lb_msg, $lb_prior, $lb_debug);
}

sub main::lb_id_parse { $bsc->bluestem_id_parse(@_) }
sub main::lb_id_short { $bsc->bluestem_id_short(@_) }
sub main::lb_id_full  { $bsc->bluestem_id_full(@_) }
sub main::lb_log      { $bsc->log(@_) }

sub cookie_read {
	my($cacheid,$clientkey,$paservers) = $bsc->read_sessioncookies()
		or return '';
	return "$cacheid~$clientkey";
}

1;
